#include "colors.inc" 
#include "brouillon2.pov"
#include "mgrass.pov"
#include "extree1.pov"




global_settings {assumed_gamma 2.2 max_trace_level 10}
camera { location <0,8,-50> look_at y*10}        //lookat y*10
light_source {<500,500,-10000> color White area_light <-10,-10,-10>,<10,10,10>,3,6 adaptive 1 jitter}
light_source {<10,-10,-0> color White*.5 shadowless}
light_source {<-25,0,16> color White*.8 shadowless} 


background { SkyBlue}
difference {
        height_field{tga "hfjardin.tga" pigment {Brown} //scale <20,2,40> translate -30*z}
                scale <400,6,400> translate <-200,-7,-150> smooth}
        object{lit scale <5,5,.8> rotate -60*y translate <1,-22,-30>}}//scale <3,7,1.2> rotate -60*y translate <1,-30,-30>} } 


plane {y,-5 pigment {Yellow}}
//box {-1,1 pigment {Red} scale <1,2,5> translate -20*z  } 

 
#declare txtherbe = 
texture{pigment{bozo color_map { [.3 rgb <.302,.537,.278>]
                                 [.6 rgb <.216,.792,.388>]
                                 [.9 rgb <.322,.788,.145>]
                                 [.95 rgb <.714,.725,.275>]
                                 [1 rgb <.302,.537,.278>]}turbulence 2} 
                                 finish{ambient .01 diffuse .4}   }


 
 
// --------------------------------------
// Patch parameters
// --------------------------------------
// Final number of triangles = nBlade x nBlade x segBlade x 2 (or 4 if dofold = true)
// --------------------------------------
#declare lPatch=10;               // size of patch
#declare nBlade=20;                // number of blades per line (there will be nBlade x nBlade blades)
//#declare nBlade=4;                // number of blades per line (there will be nBlade x nBlade blades)
#declare ryBlade = 0;            // initial y rotation of blade
#declare segBlade= 10;            // number of blade segments
#declare lBlade = 1.7;             // length of blade
#declare wBlade = 0.2;            // width of blade at start
#declare wBladeEnd = 0.1;         // width of blade at the end
#declare doSmooth=false;          // true makes smooth triangles
#declare startBend = <0,1,0.3>;   // bending of blade at start (<0,1,0>=no bending)
#declare vBend = <0,1,0>;         // force bending the blade (<0,1,1> = 45)
#declare pwBend = 4;              // bending power (how slowly the curve bends)
#declare rd = 459;                // seed
#declare stdposBlade = 1;         // standard deviation of blade position 0..1
#declare stdrotBlade = 360;       // standard deviation of rotation
#declare stdBlade = 1.2;           // standard deviation of blade scale
#declare stdBend = 3;            // standard deviation of blade bending
#declare dofold = true;          // true creates a central fold in the blade (twice more triangles)
#declare dofile = true;          // true creates a mesh file
#declare fname = "fgrass2.inc"     // name of the mesh file to create

// --------------------------------------
// Prairie parameters
// --------------------------------------
#declare nxPrairie=1;             // number of patches for the first line
#declare addPatches=1;            // number of patches to add at each line
#declare nzPrairie=10;             // number of lines of patches
#declare rd=seed(779);            // random seed
#declare stdscale=1;              // stddev of scale
#declare stdrotate=1;             // stddev of rotation
#declare doTest=false;            // replaces the patch with a sphere

// --------------------------------------
// Create the patch and the prairie
// --------------------------------------
#if (dofile=true) // if the patch is already created, turn off the next line
       //MakeGrassPatch(lPatch,nBlade,ryBlade,segBlade,lBlade,wBlade,wBladeEnd,doSmooth,startBend,vBend,pwBend,rd,stdposBlade,stdrotBlade,stdBlade,stdBend,dofold,dofile,fname)
        #declare objectPatch=#include fname
#else        
        #declare objectPatch=object{MakeGrassPatch(lPatch,nBlade,ryBlade,segBlade,lBlade,wBlade,wBladeEnd,doSmooth,startBend,vBend,pwBend,rd,stdposBlade,stdrotBlade,stdBlade,stdBend,dofold,dofile,fname)}
#end        
#declare finalherbe =
object{MakePrairie(lPatch,nxPrairie,addPatches,nzPrairie,objectPatch,rd,stdscale,stdrotate,doTest)
texture{txtherbe } translate -2*y 
}
//difference { union{
//object{finalherbe }  object{finalherbe rotate 45*y}  object{finalherbe rotate 90*y}
/*object{finalherbe rotate 135*y} object{finalherbe rotate 180*y}*/ 
//}object{lit scale <3,17,1.2> rotate -60*y translate <1,-30,-30>} }
  
        object{finalherbe rotate 225*y}
        object{finalherbe rotate 270*y} object{finalherbe rotate 315*y} 
        object{finalherbe rotate 360*y}
        object{finalherbe rotate 225*y translate <82,0,-7> rotate -25*y}
        object{finalherbe rotate 225*y translate <120,0,30> rotate 0*y}  
                                                                   
      
                                                      
//cylinder{0,y*30,5 texture{txtGrass scale 40}}

//plane{y,0 pigment{Tan}} 
//object {herbe} 

#declare maisonfinale =
union{
///////////////////////////////////////////maison/////////////////////////

object{fmaison 
        texture{wood texture_map {[0.5 T_Wood31]
                [1 texplanche ]} rotate 90*y scale 2 }
                       }
/////////////////////////////////////////fentres//////////////////////////
object{fenetre1 hollow rotate -65*y scale <1.4,1,1>}
object {fenetre2 hollow rotate -65*y scale <1.4,1,1>}
object {fenetre3 hollow rotate -65*y scale <1.4,1,1>}
//////////////////////////////////////////porte/////////////////////////////
box{<-10,5,-9>,<-9.8,-10,-3> texture{T_Wood31} rotate -55*y translate <-.7,0,-3.6>}//porte
difference{    // contour de la porte
box{<-10.3,5.3,-9.3>,<-10.1,-10.3,-3.3> rotate -56*y translate <-2,0,-4.1>}
box{<-11,5,-9>,<-9.8,-10,-3>rotate -55*y translate <-2,0,-4.1>}
pigment{Black}translate <1.3,0,.5>}
//////////////////////////////////////poigne/////////////////////////////// 
object{poignee scale .05 translate <-18,-2.5,-11> rotate -55*y
texture{pigment{rgb <.424,.592,.341>} 
finish{ambient .5 diffuse .7 phong .5 phong_size 5 metallic}}}         } 
///////////////////////////////////translation de la maison//////////////////
object{maisonfinale translate <-30,10,60> scale<1.3,1.3,1>} 
////////////////////////////////// PUIT //////////////////////////////////
object{puit scale .5 translate <-5,5,-3>}
///////////////////////////////// Bouquet de Tulipes autours du puit /////////
object{bouquettulipe scale .5 translate <-5,3.5,-3>}        
                
 
 #declare txtTree=texture{txtTree_5}
#declare txtLeaf=texture{txtLeaf_0}
#declare Leaf=object{#include "gtleaf1.inc"} // declares the Leaf object
#declare Tree1=object{#include "gttree1.inc"
//        texture{txtTree} // remove if the tree was textured with dotexture=true
}                        
// remove the following for leafless tree or for test
#declare Foliage1=object{#include "gtfoliage1.inc"
        texture{txtLeaf} 
}
                                                     
union{
     object{Tree1}
     object{Foliage1}
scale <.8,1.3,1.3>  translate <8,-1,-28>}      

//object{lit scale <1,5,1.5> rotate -60*y translate <1,-20,-30>}
object {lit scale <5,5,.8> rotate -60*y translate <1,-22,-30> 
texture {pigment {color rgbt <0,0,0,1>}finish {ambient 0 diffuse 0}
normal {bumps 0.5 scale <0.25,20,5>}} 

interior {    
media {
   intervals 30
   emission .5
   absorption .5
   density {
    waves
    turbulence 1
    omega 1
    color_map {
      [0.0 color rgb <.345,.886,.945>]
      [0.7 color rgb <0,0,1>]
      [1.0 color rgb <.341,.651,.992>]
      }
    }
    scale <1,1,5>
    rotate <0,90,0>
    } 
    }
  hollow
  }               
  union{
 object{pondz }
 object{flamme10} scale <.2,.3,.3> translate <5,0,-37>} 
  
  #declare bouquet1 =
  union{
     object{plant11  }
     object{plant12  }
     object{plant13  }
     texture{ finish {ambient .6 diffuse .3}} 
     scale .1   translate <-25,-3,17>}
     #declare bouquet2 =
     union{
     object{plant15}
     object{plant14}    
     
     texture{ finish {ambient .6 diffuse .3}} 
     scale .1 translate <-30,-3,17>}   
     
     union{
     object{bouquet1 translate -10*z}
     object{bouquet1 translate <-10,0,-20>}
     object{bouquet2 translate <10,0,-20>}
     object{bouquet2}
     object{bouquet2 translate <-15,0,-10>}} 
     
     #declare piq = object{
     prism{
     linear_sweep
     linear_spline
     0,.5,6
     <0,0>,<0,2>,<.5,2.5>,<1,2>,<1,0>,<0,0>
     pigment{Yellow} rotate -90*x translate <-25,-3,-6> }}
     
    
   
  object{piquets scale <1,2,1> translate 5*y}      
  
  union{
object{faisceau} 
object{faisceau translate -4*x} 
object{faisceau translate 4*x}

object{faisceau scale <.4,2,.4> rotate -90*x translate <1.7,1,0>} 
object{faisceau scale <.4,2,.4> translate 4*x rotate -90*x translate <1.7,1,0>}
object{faisceau scale <.4,2,.4> translate -4*x rotate 90*x translate <1.7,1,0>}

object{faisceau scale <.4,2,.4> rotate 90*x translate <1.7,-3,0>} 
object{faisceau scale <.4,2,.4> translate 4*x rotate 90*x translate <1.7,-3,0>}
object{faisceau scale <.4,2,.4> translate -4*x rotate -90*x translate <1.7,-3,0>}

object{faisceau scale <.4,2,.4> rotate -90*x translate <1.7,5,0>} 
object{faisceau scale <.4,2,.4> translate 4*x rotate 90*x translate <1.7,5,0>}
object{faisceau scale <.4,2,.4> translate -4*x rotate 90*x translate <1.7,5,0>}
    
scale .5 translate <-5,5,-3> }   

torus {5,.5 pigment{rgbft <.197,.244,.250,.7,.6>} interior{ior 1.5} 
finish{ reflection .3 ambient .1 diffuse .3 phong .5 phong_size 5} 
translate <-5,15,0>} 

torus {5,.5 pigment{rgbft <.197,.244,.250,.7,.6>} interior{ior 1.5} 
finish{ reflection .3 ambient .1 diffuse .3 phong .5 phong_size 5} 
translate <-5,20,0>}
torus {5,.5 pigment{rgbft <.197,.244,.250,.7,.6>} interior{ior 1.5} finish{ reflection .3 ambient .1 diffuse .3 phong .5 phong_size 5}  
translate <-5,25,0>}
torus {5,.5 pigment{rgbft <.197,.244,.250,.7,.6>} interior{ior 1.5}
finish{ reflection .3 ambient .1 diffuse .3 phong .5 phong_size 5}  
translate <-5,30,0>}   


cylinder{<0,1,0>,<0,15,0>,2
texture{T_Glass4} 
scale <5,5,2> translate <0,6.5,0> scale .5 translate <-5,5,-3> hollow}

object{crystal scale .03 translate <0,15,0>}
object{crystal scale .03 translate <0,20,0>}
object{crystal scale .03 translate <0,25,0>}
object{crystal scale .03 translate <0,30,0>}
object{crystal scale .03 translate <-10,30,0>}
object{crystal scale .03 translate <-10,25,0>}
object{crystal scale .03 translate <-10,20,0>}
object{crystal scale .03 translate <-10,15,0>}         
                                                              
                                                              
rainbow {
  angle 40
  width 5
  arc_angle 180
  falloff_angle 27
  distance 10000000 
  up <2,0,10>
  direction <-.1, -.3, 1>
  jitter .015
  color_map {
      [1/7 color rgb Rouge transmit .7]
      [2/7 color rgb Jaune transmit .7]
      [3/7 color rgb Vert transmit .7] 
      [4/7 color rgb BleuC transmit .7]
      [5/7 color rgb BleuF transmit .7]
      [6/7 color rgb Violet1 transmit .7]
      [7/7 color rgb Rose transmit .7]}
}  

height_field {tga "hfjard2.tga" smooth scale <1000,45,300> rotate 180*z 
                                translate <50,25,200> scale <.5,4,1>
                                texture{textmont1} 
                                texture{textmont2} }
height_field {tga "hfjard2.tga"  smooth scale <100,45,150> rotate 180*z 
                                translate <100,25,200> scale <2,4,1>
                                texture{textmont1} texture{textmont2} }  
                                
fog {fog_type 2
distance 50
color rgbt .5*.8
fog_offset 7
fog_alt 3
turbulence 2 
octaves 3
omega .7
lambda 5
turb_depth .5 
/*up <0,-1,-10>*/} 

/*fog {fog_type 2
distance 10
color rgbt <.5,.5,.5,.5>*.8
fog_offset 3
fog_alt 2
turbulence 2
turb_depth .5 
octaves 3
omega .7
lambda 5 

turb_depth 2 
up <0,-1,-10>}*/     

object{piaffz rotate -140*y scale .15 translate <-35,53,62.5>}

  
 
  
                                                                                                                